! $Id: omegalib.nw,v 1.118.4.1 2005/11/07 01:50:16 ohl Exp $
!
! Copyright (C) 2000-2002 by Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
! and others
!
! O'Mega is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! O'Mega is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
module omega_bispinor_couplings
  use omega_kinds
  use omega_constants
  use omega_bispinors
  use omega_vectorspinors
  use omega_vectors
  implicit none
  private
  public :: u, v, ghost       
  public :: brs_u, brs_v
  public :: va_ff, v_ff, a_ff, vl_ff, vr_ff, vlr_ff
  public :: f_vaf, f_vf, f_af, f_vlf, f_vrf, f_vlrf   
  public :: sp_ff, s_ff, p_ff, sl_ff, sr_ff, slr_ff
  public :: f_spf, f_sf, f_pf, f_slf, f_srf, f_slrf
  private :: vv_ff, f_vvf
  public :: vmom_ff, mom_ff, mom5_ff, moml_ff, momr_ff, lmom_ff, rmom_ff
  public :: f_vmomf, f_momf, f_mom5f, f_momlf, f_momrf, f_lmomf, f_rmomf
  public :: s2_ff, v2_ff, sv1_ff, sv2_ff, pv1_ff, pv2_ff, svl1_ff, svl2_ff, &
       svr1_ff, svr2_ff, svlr1_ff, svlr2_ff  
  public :: f_s2f, f_v2f, f_svf, f_pvf, f_svlf, f_svrf, f_svlrf
  public :: pot_grf, pot_fgr, s_grf, s_fgr, p_grf, p_fgr
  private :: fgvgr, fgvg5gr, fggvvgr, grkgf, grkggf, grkkggf, &
             fgkgr, fg5gkgr, grvgf, grg5vgf, grkgggf, fggkggr
  public :: f_potgr, f_sgr, f_pgr, f_vgr
  public :: gr_potf, gr_sf, gr_pf, gr_vf
  public :: v_grf, v_fgr 
  public :: f_s2gr, f_svgr, f_pvgr, f_v2gr
  public :: gr_s2f, gr_svf, gr_pvf, gr_v2f
  public :: s2_grf, s2_fgr, sv1_grf, sv2_grf, sv1_fgr, sv2_fgr, &
            pv1_grf, pv2_grf, pv1_fgr, pv2_fgr, v2_grf, v2_fgr
  public :: pr_psi, pr_grav 
  public :: pj_psi
  integer, parameter, public :: omega_bispinor_cpls_2003_03_A = 0
contains
  pure function u (m, p, s) result (psi)
    type(bispinor) :: psi
    real(kind=omega_prec), intent(in) :: m
    type(momentum), intent(in) :: p
    integer, intent(in) :: s
    complex(kind=omega_prec), dimension(2) :: chip, chim
    real(kind=omega_prec) :: pabs, norm
    pabs = sqrt (dot_product (p%x, p%x))
    if (1 + p%x(3) / pabs <= epsilon (pabs)) then
       chip = (/ cmplx ( 0.0, 0.0, kind=omega_prec), &
                 cmplx ( 1.0, 0.0, kind=omega_prec) /)
       chim = (/ cmplx (-1.0, 0.0, kind=omega_prec), &
                 cmplx ( 0.0, 0.0, kind=omega_prec) /)
    else
       norm = 1 / sqrt (2*pabs*(pabs + p%x(3)))
       chip = norm * (/ cmplx (pabs + p%x(3), kind=omega_prec), &
                        cmplx (p%x(1), p%x(2), kind=omega_prec) /)
       chim = norm * (/ cmplx (-p%x(1), p%x(2), kind=omega_prec), &
                        cmplx (pabs + p%x(3), kind=omega_prec) /)
    end if
    if (s > 0) then
       psi%a(1:2) = sqrt (max (p%t - pabs, 0.0_omega_prec)) * chip
       psi%a(3:4) = sqrt (p%t + pabs) * chip
    else
       psi%a(1:2) = sqrt (p%t + pabs) * chim
       psi%a(3:4) = sqrt (max (p%t - pabs, 0.0_omega_prec)) * chim
    end if
    pabs = m ! make the compiler happy and use m
  end function u
  !pure function u (m, p, s) result (psi)
  !  type(bispinor) :: psi
  !  real(kind=omega_prec), intent(in) :: m
  !  type(momentum), intent(in) :: p
  !  integer, intent(in) :: s
  !  complex(kind=omega_prec), dimension(2) :: chip, chim
  !  real(kind=omega_prec) :: pabs, norm
  !  pabs = sqrt (dot_product (p%x, p%x))
  !  if (p%x(3) <= epsilon(p%x(3))) then
  !     chip = (/ cmplx ( 0.0, 0.0, kind=omega_prec), &
  !               cmplx ( 1.0, 0.0, kind=omega_prec) /)
  !     chim = (/ cmplx (-1.0, 0.0, kind=omega_prec), &
  !               cmplx ( 0.0, 0.0, kind=omega_prec) /)
  !     else
  !        if (1 + p%x(3) / pabs <= epsilon (pabs)) then
  !           chip = (/ cmplx ( 0.0, 0.0, kind=omega_prec), &
  !                     cmplx ( 1.0, 0.0, kind=omega_prec) /)
  !           chim = (/ cmplx (-1.0, 0.0, kind=omega_prec), &
  !                     cmplx ( 0.0, 0.0, kind=omega_prec) /)
  !        else
  !           norm = 1 / sqrt (2*pabs*(pabs + p%x(3)))
  !           chip = norm * (/ cmplx (pabs + p%x(3), kind=omega_prec), &
  !                            cmplx (p%x(1), p%x(2), kind=omega_prec) /)
  !           chim = norm * (/ cmplx (-p%x(1), p%x(2), kind=omega_prec), &
  !                            cmplx (pabs + p%x(3), kind=omega_prec) /)
  !        end if
  !  end if
  !  if (s > 0) then
  !     psi%a(1:2) = sqrt (max (p%t - pabs, 0.0_omega_prec)) * chip
  !     psi%a(3:4) = sqrt (p%t + pabs) * chip
  !  else
  !     psi%a(1:2) = sqrt (p%t + pabs) * chim
  !     psi%a(3:4) = sqrt (max (p%t - pabs, 0.0_omega_prec)) * chim
  !  end if
  !  pabs = m ! make the compiler happy and use m
  !end function u  
  pure function v (m, p, s) result (psi)
    type(bispinor) :: psi
    real(kind=omega_prec), intent(in) :: m
    type(momentum), intent(in) :: p
    integer, intent(in) :: s
    complex(kind=omega_prec), dimension(2) :: chip, chim
    real(kind=omega_prec) :: pabs, norm
    pabs = sqrt (dot_product (p%x, p%x))
    if (1 + p%x(3) / pabs <= epsilon (pabs)) then
       chip = (/ cmplx ( 0.0, 0.0, kind=omega_prec), &
                 cmplx ( 1.0, 0.0, kind=omega_prec) /)
       chim = (/ cmplx (-1.0, 0.0, kind=omega_prec), &
                 cmplx ( 0.0, 0.0, kind=omega_prec) /)
    else
       norm = 1 / sqrt (2*pabs*(pabs + p%x(3)))
       chip = norm * (/ cmplx (pabs + p%x(3), kind=omega_prec), &
                        cmplx (p%x(1), p%x(2), kind=omega_prec) /)
       chim = norm * (/ cmplx (-p%x(1), p%x(2), kind=omega_prec), &
                        cmplx (pabs + p%x(3), kind=omega_prec) /)
    end if
    if (s > 0) then
       psi%a(1:2) = - sqrt (p%t + pabs) * chim
       psi%a(3:4) =   sqrt (max (p%t - pabs, 0.0_omega_prec)) * chim
    else
       psi%a(1:2) =   sqrt (max (p%t - pabs, 0.0_omega_prec)) * chip
       psi%a(3:4) = - sqrt (p%t + pabs) * chip
    end if
    pabs = m ! make the compiler happy and use m
  end function v
  !pure function v (m, p, s) result (psi)
  !  type(bispinor) :: psi
  !  real(kind=omega_prec), intent(in) :: m
  !  type(momentum), intent(in) :: p
  !  integer, intent(in) :: s
  !  complex(kind=omega_prec), dimension(2) :: chip, chim
  !  real(kind=omega_prec) :: pabs, norm
  !  pabs = sqrt (dot_product (p%x, p%x))
  !  if (p%x(3) <= epsilon (p%x(3))) then 
  !     chip = (/ cmplx ( 1.0, 0.0, kind=omega_prec), &
  !               cmplx ( 0.0, 0.0, kind=omega_prec) /)
  !     chim = (/ cmplx ( 0.0, 0.0, kind=omega_prec), &
  !               cmplx ( 1.0, 0.0, kind=omega_prec) /)
  !     else
  !        if (1 + p%x(3) / pabs <= epsilon (pabs)) then
  !           chip = (/ cmplx ( 0.0, 0.0, kind=omega_prec), &
  !                     cmplx ( 1.0, 0.0, kind=omega_prec) /)
  !           chim = (/ cmplx (-1.0, 0.0, kind=omega_prec), &
  !                     cmplx ( 0.0, 0.0, kind=omega_prec) /)
  !        else
  !           norm = 1 / sqrt (2*pabs*(pabs + p%x(3)))
  !           chip = norm * (/ cmplx (pabs + p%x(3), kind=omega_prec), &
  !                            cmplx (p%x(1), p%x(2), kind=omega_prec) /)
  !           chim = norm * (/ cmplx (-p%x(1), p%x(2), kind=omega_prec), &
  !                            cmplx (pabs + p%x(3), kind=omega_prec) /)
  !        end if
  !  end if
  !  if (s > 0) then
  !     psi%a(1:2) = - sqrt (p%t + pabs) * chim
  !     psi%a(3:4) =   sqrt (max (p%t - pabs, 0.0_omega_prec)) * chim
  !  else
  !     psi%a(1:2) =   sqrt (max (p%t - pabs, 0.0_omega_prec)) * chip
  !     psi%a(3:4) = - sqrt (p%t + pabs) * chip
  !  end if
  !  pabs = m ! make the compiler happy and use m
  !end function v
  pure function ghost (m, p, s) result (psi) 
      type(bispinor) :: psi
      real(kind=omega_prec), intent(in) :: m 
      type(momentum), intent(in) :: p 
      integer, intent(in) :: s    
      psi%a(:) = 0
      select case (s)
      case (1)
          psi%a(1)   = 1
          psi%a(2:4) = 0 
      case (2)
          psi%a(1)   = 0
          psi%a(2)   = 1
          psi%a(3:4) = 0
      case (3)
          psi%a(1:2) = 0
          psi%a(3)   = 1
          psi%a(4)   = 0   
      case (4) 
          psi%a(1:3) = 0
          psi%a(4)   = 1  
      case (5)
          psi%a(1) =    1.4
          psi%a(2) = -  2.3
          psi%a(3) = - 71.5
          psi%a(4) =    0.1
      end select 
  end function ghost
  pure function brs_u (m, p, s) result (dpsi)
      type(bispinor) :: dpsi, psi
      real(kind=omega_prec), intent(in) :: m
      type(momentum), intent(in) :: p
      integer, intent(in) :: s
      type (vector)::vp
      complex(kind=omega_prec), parameter :: one = (1, 0)
      vp=p
      psi=u(m,p,s)
      dpsi=cmplx(0.0,-1.0)*(f_vf(one,vp,psi)-m*psi)
  end function brs_u
  pure function brs_v (m, p, s) result (dpsi)
      type(bispinor) :: dpsi, psi
      real(kind=omega_prec), intent(in) :: m
      type(momentum), intent(in) :: p
      integer, intent(in) ::   s
      type (vector)::vp
      complex(kind=omega_prec), parameter :: one = (1, 0)
      vp=p
      psi=v(m,p,s)
      dpsi=cmplx(0.0,1.0)*(f_vf(one,vp,psi)+m*psi)
  end function brs_v
  pure function va_ff (gv, ga, psil, psir) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), intent(in) :: psil, psir
    complex(kind=omega_prec) :: gl, gr
    complex(kind=omega_prec) :: g13, g14, g23, g24, g31, g32, g41, g42
    gl = gv + ga
    gr = gv - ga
    g13 = psil%a(1)*psir%a(3)
    g14 = psil%a(1)*psir%a(4)
    g23 = psil%a(2)*psir%a(3)
    g24 = psil%a(2)*psir%a(4)
    g31 = psil%a(3)*psir%a(1)
    g32 = psil%a(3)*psir%a(2)
    g41 = psil%a(4)*psir%a(1)
    g42 = psil%a(4)*psir%a(2)
    j%t    =  gr * (   g14 - g23) + gl * ( - g32 + g41)
    j%x(1) =  gr * (   g13 - g24) + gl * (   g31 - g42)
    j%x(2) = (gr * (   g13 + g24) + gl * (   g31 + g42)) * (0, 1)
    j%x(3) =  gr * ( - g14 - g23) + gl * ( - g32 - g41)
  end function va_ff 
  pure function v_ff (gv, psil, psir) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: gv
    type(bispinor), intent(in) :: psil, psir
    complex(kind=omega_prec) :: g13, g14, g23, g24, g31, g32, g41, g42
    g13 = psil%a(1)*psir%a(3)
    g14 = psil%a(1)*psir%a(4)
    g23 = psil%a(2)*psir%a(3)
    g24 = psil%a(2)*psir%a(4)
    g31 = psil%a(3)*psir%a(1)
    g32 = psil%a(3)*psir%a(2)
    g41 = psil%a(4)*psir%a(1)
    g42 = psil%a(4)*psir%a(2)
    j%t    =   gv * (   g14 - g23 - g32 + g41)
    j%x(1) =   gv * (   g13 - g24 + g31 - g42)
    j%x(2) =   gv * (   g13 + g24 + g31 + g42) * (0, 1)
    j%x(3) =   gv * ( - g14 - g23 - g32 - g41)
  end function v_ff           
  pure function a_ff (ga, psil, psir) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: ga
    type(bispinor), intent(in) :: psil, psir
    complex(kind=omega_prec) :: g13, g14, g23, g24, g31, g32, g41, g42
    g13 = psil%a(1)*psir%a(3)
    g14 = psil%a(1)*psir%a(4)
    g23 = psil%a(2)*psir%a(3)
    g24 = psil%a(2)*psir%a(4)
    g31 = psil%a(3)*psir%a(1)
    g32 = psil%a(3)*psir%a(2)
    g41 = psil%a(4)*psir%a(1)
    g42 = psil%a(4)*psir%a(2)
    j%t    =  -ga * (   g14 - g23 + g32 - g41)
    j%x(1) =  -ga * (   g13 - g24 - g31 + g42)
    j%x(2) =  -ga * (   g13 + g24 - g31 - g42) * (0, 1)
    j%x(3) =  -ga * ( - g14 - g23 + g32 + g41)
  end function a_ff      
  pure function vl_ff (gl, psil, psir) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: gl
    type(bispinor), intent(in) :: psil, psir
    complex(kind=omega_prec) :: gl2
    complex(kind=omega_prec) :: g31, g32, g41, g42
    gl2 = 2 * gl
    g31 = psil%a(3)*psir%a(1)
    g32 = psil%a(3)*psir%a(2)
    g41 = psil%a(4)*psir%a(1)
    g42 = psil%a(4)*psir%a(2)
    j%t    =   gl2 * ( - g32 + g41)
    j%x(1) =   gl2 * (   g31 - g42)
    j%x(2) =   gl2 * (   g31 + g42) * (0, 1)
    j%x(3) =   gl2 * ( - g32 - g41)
  end function vl_ff      
  pure function vr_ff (gr, psil, psir) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: gr
    type(bispinor), intent(in) :: psil, psir
    complex(kind=omega_prec) :: gr2
    complex(kind=omega_prec) :: g13, g14, g23, g24
    gr2 = 2 * gr
    g13 = psil%a(1)*psir%a(3)
    g14 = psil%a(1)*psir%a(4)
    g23 = psil%a(2)*psir%a(3)
    g24 = psil%a(2)*psir%a(4)
    j%t    = gr2 * (   g14 - g23)
    j%x(1) = gr2 * (   g13 - g24)
    j%x(2) = gr2 * (   g13 + g24) * (0, 1)
    j%x(3) = gr2 * ( - g14 - g23)
  end function vr_ff      
  pure function vlr_ff (gl, gr, psibar, psi) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), intent(in) :: psibar
    type(bispinor), intent(in) :: psi
    j = va_ff (gl+gr, gl-gr, psibar, psi)
  end function vlr_ff
  pure function f_vaf (gv, ga, v, psi) result (vpsi)
    type(bispinor) :: vpsi
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(vector), intent(in) :: v
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec) :: gl, gr
    complex(kind=omega_prec) :: vp, vm, v12, v12s
    gl = gv + ga
    gr = gv - ga
    vp = v%t + v%x(3)
    vm = v%t - v%x(3)
    v12  =  v%x(1) + (0,1)*v%x(2)
    v12s =  v%x(1) - (0,1)*v%x(2)
    vpsi%a(1) = gr * (   vm  * psi%a(3) - v12s * psi%a(4))
    vpsi%a(2) = gr * ( - v12 * psi%a(3) + vp   * psi%a(4))
    vpsi%a(3) = gl * (   vp  * psi%a(1) + v12s * psi%a(2))
    vpsi%a(4) = gl * (   v12 * psi%a(1) + vm   * psi%a(2))
  end function f_vaf   
  pure function f_vf (gv, v, psi) result (vpsi)
    type(bispinor) :: vpsi
    complex(kind=omega_prec), intent(in) :: gv
    type(vector), intent(in) :: v
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec) :: vp, vm, v12, v12s
    vp = v%t + v%x(3)
    vm = v%t - v%x(3)
    v12  =  v%x(1) + (0,1)*v%x(2)
    v12s =  v%x(1) - (0,1)*v%x(2)
    vpsi%a(1) = gv * (   vm  * psi%a(3) - v12s * psi%a(4))
    vpsi%a(2) = gv * ( - v12 * psi%a(3) + vp   * psi%a(4))
    vpsi%a(3) = gv * (   vp  * psi%a(1) + v12s * psi%a(2))
    vpsi%a(4) = gv * (   v12 * psi%a(1) + vm   * psi%a(2))
  end function f_vf    
  pure function f_af (ga, v, psi) result (vpsi)
    type(bispinor) :: vpsi
    complex(kind=omega_prec), intent(in) :: ga
    type(vector), intent(in) :: v
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec) :: vp, vm, v12, v12s
    vp = v%t + v%x(3)
    vm = v%t - v%x(3)
    v12  =  v%x(1) + (0,1)*v%x(2)
    v12s =  v%x(1) - (0,1)*v%x(2)
    vpsi%a(1) = ga * ( - vm  * psi%a(3) + v12s * psi%a(4))
    vpsi%a(2) = ga * (   v12 * psi%a(3) - vp   * psi%a(4))
    vpsi%a(3) = ga * (   vp  * psi%a(1) + v12s * psi%a(2))
    vpsi%a(4) = ga * (   v12 * psi%a(1) + vm   * psi%a(2))
  end function f_af   
  pure function f_vlf (gl, v, psi) result (vpsi)
    type(bispinor) :: vpsi
    complex(kind=omega_prec), intent(in) :: gl
    type(vector), intent(in) :: v
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec) :: gl2
    complex(kind=omega_prec) :: vp, vm, v12, v12s
    gl2 = 2 * gl
    vp = v%t + v%x(3)
    vm = v%t - v%x(3)
    v12  =  v%x(1) + (0,1)*v%x(2)
    v12s =  v%x(1) - (0,1)*v%x(2)
    vpsi%a(1) = 0
    vpsi%a(2) = 0
    vpsi%a(3) = gl2 * (   vp  * psi%a(1) + v12s * psi%a(2))
    vpsi%a(4) = gl2 * (   v12 * psi%a(1) + vm   * psi%a(2))
  end function f_vlf 
  pure function f_vrf (gr, v, psi) result (vpsi)
    type(bispinor) :: vpsi
    complex(kind=omega_prec), intent(in) :: gr
    type(vector), intent(in) :: v
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec) :: gr2
    complex(kind=omega_prec) :: vp, vm, v12, v12s
    gr2 = 2 * gr
    vp = v%t + v%x(3)
    vm = v%t - v%x(3)
    v12  =  v%x(1) + (0,1)*v%x(2)
    v12s =  v%x(1) - (0,1)*v%x(2)
    vpsi%a(1) = gr2 * (   vm  * psi%a(3) - v12s * psi%a(4))
    vpsi%a(2) = gr2 * ( - v12 * psi%a(3) + vp   * psi%a(4))
    vpsi%a(3) = 0
    vpsi%a(4) = 0
  end function f_vrf
  pure function f_vlrf (gl, gr, v, psi) result (vpsi)
    type(bispinor) :: vpsi
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(vector), intent(in) :: v
    type(bispinor), intent(in) :: psi
    vpsi = f_vaf (gl+gr, gl-gr, v, psi)
  end function f_vlrf
  pure function sp_ff (gs, gp, psil, psir) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: gs, gp
    type(bispinor), intent(in) :: psil, psir
    j =    (gs - gp) * (psil%a(1)*psir%a(2) - psil%a(2)*psir%a(1)) &
         + (gs + gp) * (- psil%a(3)*psir%a(4) + psil%a(4)*psir%a(3))
  end function sp_ff
  pure function s_ff (gs, psil, psir) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: gs
    type(bispinor), intent(in) :: psil, psir
    j = gs * (psil * psir)
  end function s_ff
  pure function p_ff (gp, psil, psir) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: gp
    type(bispinor), intent(in) :: psil, psir
    j = gp * (- psil%a(1)*psir%a(2) + psil%a(2)*psir%a(1) &
              - psil%a(3)*psir%a(4) + psil%a(4)*psir%a(3))
  end function p_ff
  pure function sl_ff (gl, psil, psir) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: gl
    type(bispinor), intent(in) :: psil, psir
    j =  2 * gl * (psil%a(1)*psir%a(2) - psil%a(2)*psir%a(1))
  end function sl_ff
  pure function sr_ff (gr, psil, psir) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: gr
    type(bispinor), intent(in) :: psil, psir
    j = 2 * gr * (- psil%a(3)*psir%a(4) + psil%a(4)*psir%a(3))
  end function sr_ff    
  pure function slr_ff (gl, gr, psibar, psi) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), intent(in) :: psibar
    type(bispinor), intent(in) :: psi
    j = sp_ff (gr+gl, gr-gl, psibar, psi)
  end function slr_ff
  pure function f_spf (gs, gp, phi, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: gs, gp
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    phipsi%a(1:2) = ((gs - gp) * phi) * psi%a(1:2)
    phipsi%a(3:4) = ((gs + gp) * phi) * psi%a(3:4)
  end function f_spf
  pure function f_sf (gs, phi, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: gs
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    phipsi%a = (gs * phi) * psi%a
  end function f_sf
  pure function f_pf (gp, phi, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: gp
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    phipsi%a(1:2) = (- gp * phi) * psi%a(1:2)
    phipsi%a(3:4) = (  gp * phi) * psi%a(3:4)
  end function f_pf
  pure function f_slf (gl, phi, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: gl
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    phipsi%a(1:2) = (2 * gl * phi) * psi%a(1:2)
    phipsi%a(3:4) = 0
  end function f_slf 
  pure function f_srf (gr, phi, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: gr
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    phipsi%a(1:2) = 0
    phipsi%a(3:4) = (2 * gr * phi) * psi%a(3:4)
  end function f_srf                  
  pure function f_slrf (gl, gr, phi, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: gl, gr
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    phipsi =  f_spf (gr+gl, gr-gl, phi, psi)
  end function f_slrf
  pure function vv_ff (psibar, psi, k) result (psibarpsi)
    type(vector) :: psibarpsi
    type(bispinor), intent(in) :: psibar, psi
    type(vector), intent(in) :: k 
    complex(kind=omega_prec) :: kp, km, k12, k12s
    type(bispinor) :: kgpsi1, kgpsi2, kgpsi3, kgpsi4
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2)
    kgpsi1%a(1) = -k%x(3) * psi%a(1) - k12s * psi%a(2) 
    kgpsi1%a(2) = -k12 * psi%a(1) + k%x(3) * psi%a(2) 
    kgpsi1%a(3) = k%x(3) * psi%a(3) + k12s * psi%a(4)
    kgpsi1%a(4) = k12 * psi%a(3) - k%x(3) * psi%a(4)
    kgpsi2%a(1) = ((0,-1) * k%x(2)) * psi%a(1) - km * psi%a(2)
    kgpsi2%a(2) = - kp * psi%a(1) + ((0,1) * k%x(2)) * psi%a(2) 
    kgpsi2%a(3) = ((0,-1) * k%x(2)) * psi%a(3) + kp * psi%a(4)
    kgpsi2%a(4) = km * psi%a(3) + ((0,1) * k%x(2)) * psi%a(4) 
    kgpsi3%a(1) = (0,1) * (k%x(1) * psi%a(1) + km * psi%a(2))  
    kgpsi3%a(2) = (0,-1) * (kp * psi%a(1) + k%x(1) * psi%a(2)) 
    kgpsi3%a(3) = (0,1) * (k%x(1) * psi%a(3) - kp * psi%a(4))
    kgpsi3%a(4) = (0,1) * (km * psi%a(3) - k%x(1) * psi%a(4)) 
    kgpsi4%a(1) = -k%t * psi%a(1) - k12s * psi%a(2) 
    kgpsi4%a(2) = k12 * psi%a(1) + k%t * psi%a(2) 
    kgpsi4%a(3) = k%t * psi%a(3) - k12s * psi%a(4) 
    kgpsi4%a(4) = k12 * psi%a(3) - k%t * psi%a(4) 
    psibarpsi%t    = 2 * (psibar * kgpsi1)
    psibarpsi%x(1) = 2 * (psibar * kgpsi2) 
    psibarpsi%x(2) = 2 * (psibar * kgpsi3) 
    psibarpsi%x(3) = 2 * (psibar * kgpsi4)
  end function vv_ff
  pure function f_vvf (v, psi, k) result (kvpsi)
    type(bispinor) :: kvpsi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: k, v 
      complex(kind=omega_prec) :: kv30, kv21, kv01, kv31, kv02, kv32
    complex(kind=omega_prec) :: ap, am, bp, bm, bps, bms
    kv30 = k%x(3) * v%t - k%t * v%x(3)
    kv21 = (0,1) * (k%x(2) * v%x(1) - k%x(1) * v%x(2))
    kv01 = k%t * v%x(1) - k%x(1) * v%t
    kv31 = k%x(3) * v%x(1) - k%x(1) * v%x(3)
    kv02 = (0,1) * (k%t * v%x(2) - k%x(2) * v%t)
    kv32 = (0,1) * (k%x(3) * v%x(2) - k%x(2) * v%x(3))
    ap  = 2 * (kv30 + kv21)
    am  = 2 * (-kv30 + kv21)
    bp  = 2 * (kv01 + kv31 + kv02 + kv32)
    bm  = 2 * (kv01 - kv31 + kv02 - kv32) 
    bps = 2 * (kv01 + kv31 - kv02 - kv32) 
    bms = 2 * (kv01 - kv31 - kv02 + kv32)
    kvpsi%a(1) = am * psi%a(1) + bms * psi%a(2)
    kvpsi%a(2) = bp * psi%a(1) - am * psi%a(2) 
    kvpsi%a(3) = ap * psi%a(3) - bps * psi%a(4)
    kvpsi%a(4) = -bm * psi%a(3) - ap * psi%a(4) 
  end function f_vvf
  pure function vmom_ff (g, psibar, psi, k) result (psibarpsi)
    type(vector) :: psibarpsi
    complex(kind=omega_prec), intent(in) :: g 
    type(bispinor), intent(in) :: psibar, psi
    type(momentum), intent(in) :: k 
    type(vector) :: vk
    vk = k 
    psibarpsi = g * vv_ff (psibar, psi, vk)
  end function vmom_ff
  pure function mom_ff (g, m, psibar, psi, k) result (psibarpsi)
    complex(kind=omega_prec) :: psibarpsi
    type(bispinor), intent(in) :: psibar, psi
    type(momentum), intent(in) :: k 
    complex(kind=omega_prec), intent(in) :: g, m
    type(bispinor) :: kmpsi 
    complex(kind=omega_prec) :: kp, km, k12, k12s
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2)
    kmpsi%a(1) = km * psi%a(3) - k12s * psi%a(4) 
    kmpsi%a(2) = kp * psi%a(4) - k12 * psi%a(3) 
    kmpsi%a(3) = kp * psi%a(1) + k12s * psi%a(2) 
    kmpsi%a(4) = k12 * psi%a(1) + km * psi%a(2) 
    psibarpsi = g * (psibar * kmpsi) + s_ff (m, psibar, psi)
  end function mom_ff 
  pure function mom5_ff (g, m, psibar, psi, k) result (psibarpsi) 
    complex(kind=omega_prec) :: psibarpsi
    type(bispinor), intent(in) :: psibar, psi
    type(momentum), intent(in) :: k 
    complex(kind=omega_prec), intent(in) :: g, m
    type(bispinor) :: g5psi
    g5psi%a(1:2) = - psi%a(1:2)
    g5psi%a(3:4) = psi%a(3:4)
    psibarpsi = mom_ff (g, m, psibar, g5psi, k)
  end function mom5_ff 
  pure function moml_ff (g, m, psibar, psi, k) result (psibarpsi) 
    complex(kind=omega_prec) :: psibarpsi
    type(bispinor), intent(in) :: psibar, psi
    type(momentum), intent(in) :: k 
    complex(kind=omega_prec), intent(in) :: g, m
    type(bispinor) :: leftpsi
    leftpsi%a(1:2) = 2 * psi%a(1:2)
    leftpsi%a(3:4) = 0 
    psibarpsi = mom_ff (g, m, psibar, leftpsi, k)
  end function moml_ff 
  pure function momr_ff (g, m, psibar, psi, k) result (psibarpsi) 
    complex(kind=omega_prec) :: psibarpsi
    type(bispinor), intent(in) :: psibar, psi
    type(momentum), intent(in) :: k 
    complex(kind=omega_prec), intent(in) :: g, m
    type(bispinor) :: rightpsi
    rightpsi%a(1:2) = 0 
    rightpsi%a(3:4) = 2 * psi%a(3:4)
    psibarpsi = mom_ff (g, m, psibar, rightpsi, k)
  end function momr_ff 
  pure function lmom_ff (g, m, psibar, psi, k) result (psibarpsi) 
    complex(kind=omega_prec) :: psibarpsi
    type(bispinor), intent(in) :: psibar, psi
    type(momentum), intent(in) :: k 
    complex(kind=omega_prec), intent(in) :: g, m  
    psibarpsi = mom_ff  (g, m, psibar, psi, k) + & 
                mom5_ff (g,-m, psibar, psi, k) 
  end function lmom_ff 
  pure function rmom_ff (g, m, psibar, psi, k) result (psibarpsi) 
    complex(kind=omega_prec) :: psibarpsi
    type(bispinor), intent(in) :: psibar, psi
    type(momentum), intent(in) :: k 
    complex(kind=omega_prec), intent(in) :: g, m  
    psibarpsi = mom_ff  (g, m, psibar, psi, k) - & 
                mom5_ff (g,-m, psibar, psi, k) 
  end function rmom_ff 
  pure function f_vmomf (g, v, psi, k) result (kvpsi)
    type(bispinor) :: kvpsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: g
    type(momentum), intent(in) :: k
    type(vector), intent(in) :: v 
    type(vector) :: vk
    vk = k 
    kvpsi = g * f_vvf (v, psi, vk) 
  end function f_vmomf
  pure function f_momf (g, m, phi, psi, k) result (kmpsi)
    type(bispinor) :: kmpsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: phi, g, m
    type(momentum), intent(in) :: k 
    complex(kind=omega_prec) :: kp, km, k12, k12s
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2)
    kmpsi%a(1) = km * psi%a(3) - k12s * psi%a(4) 
    kmpsi%a(2) = -k12 * psi%a(3) + kp * psi%a(4) 
    kmpsi%a(3) = kp * psi%a(1) + k12s * psi%a(2) 
    kmpsi%a(4) = k12 * psi%a(1) + km * psi%a(2) 
    kmpsi = g * (phi * kmpsi) + f_sf (m, phi, psi)
  end function f_momf  
  pure function f_mom5f (g, m, phi, psi, k) result (kmpsi)
    type(bispinor) :: kmpsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: phi, g, m
    type(momentum), intent(in) :: k 
    type(bispinor) :: g5psi
    g5psi%a(1:2) = - psi%a(1:2)
    g5psi%a(3:4) =   psi%a(3:4)
    kmpsi = f_momf (g, m, phi, g5psi, k)
  end function f_mom5f  
  pure function f_momlf (g, m, phi, psi, k) result (kmpsi)
    type(bispinor) :: kmpsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: phi, g, m
    type(momentum), intent(in) :: k 
    type(bispinor) :: leftpsi 
    leftpsi%a(1:2) = 2 * psi%a(1:2)
    leftpsi%a(3:4) = 0 
    kmpsi = f_momf (g, m, phi, leftpsi, k) 
  end function f_momlf  
  pure function f_momrf (g, m, phi, psi, k) result (kmpsi)
    type(bispinor) :: kmpsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: phi, g, m
    type(momentum), intent(in) :: k 
    type(bispinor) :: rightpsi 
    rightpsi%a(1:2) = 0
    rightpsi%a(3:4) = 2 * psi%a(3:4) 
    kmpsi = f_momf (g, m, phi, rightpsi, k) 
  end function f_momrf  
  pure function f_lmomf (g, m, phi, psi, k) result (kmpsi)
    type(bispinor) :: kmpsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: phi, g, m
    type(momentum), intent(in) :: k 
    kmpsi = f_momf  (g, m, phi, psi, k) + &
            f_mom5f (g,-m, phi, psi, k) 
  end function f_lmomf  
  pure function f_rmomf (g, m, phi, psi, k) result (kmpsi)
    type(bispinor) :: kmpsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: phi, g, m
    type(momentum), intent(in) :: k 
    kmpsi = f_momf  (g, m, phi, psi, k) - &
            f_mom5f (g,-m, phi, psi, k) 
  end function f_rmomf  
  pure function s2_ff (g, psibar, phi, psi) result (phi2)
    complex(kind=omega_prec) :: phi2
    complex (kind=omega_prec), intent(in) :: g, phi
    type(bispinor), intent(in) :: psibar, psi 
    phi2 = phi * p_ff (g, psibar, psi)
  end function s2_ff
  pure function v2_ff (g, psibar, v, psi) result (v2)
    type(vector) :: v2 
    complex (kind=omega_prec), intent(in) :: g 
    type(bispinor), intent(in) :: psibar, psi 
    type(vector), intent(in) :: v
    v2 = (-g) * vv_ff (psibar, psi, v)
  end function v2_ff
  pure function sv1_ff (g, psibar, v, psi) result (phi)
    complex(kind=omega_prec) :: phi
    type(bispinor), intent(in) :: psibar, psi
    type(vector), intent(in) :: v 
    complex(kind=omega_prec), intent(in) :: g 
    phi = psibar * f_vf (g, v, psi)
  end function sv1_ff
  pure function sv2_ff (g, psibar, phi, psi) result (v)
    type(vector) :: v
    complex(kind=omega_prec), intent(in) :: phi, g
    type(bispinor), intent(in) :: psibar, psi
    v = phi * v_ff (g, psibar, psi)
  end function sv2_ff
  pure function pv1_ff (g, psibar, v, psi) result (phi)
    complex(kind=omega_prec) :: phi
    type(bispinor), intent(in) :: psibar, psi
    type(vector), intent(in) :: v 
    complex(kind=omega_prec), intent(in) :: g 
    phi = - (psibar * f_af (g, v, psi))
  end function pv1_ff
  pure function pv2_ff (g, psibar, phi, psi) result (v)
    type(vector) :: v
    complex(kind=omega_prec), intent(in) :: phi, g
    type(bispinor), intent(in) :: psibar, psi
    v = -(phi * a_ff (g, psibar, psi))
  end function pv2_ff
  pure function svl1_ff (g, psibar, v, psi) result (phi)
    complex(kind=omega_prec) :: phi
    type(bispinor), intent(in) :: psibar, psi
    type(vector), intent(in) :: v 
    complex(kind=omega_prec), intent(in) :: g 
    phi = psibar * f_vlf (g, v, psi)
  end function svl1_ff
  pure function svl2_ff (g, psibar, phi, psi) result (v)
    type(vector) :: v
    complex(kind=omega_prec), intent(in) :: phi, g
    type(bispinor), intent(in) :: psibar, psi
    v = phi * vl_ff (g, psibar, psi)
  end function svl2_ff
  pure function svr1_ff (g, psibar, v, psi) result (phi)
    complex(kind=omega_prec) :: phi
    type(bispinor), intent(in) :: psibar, psi
    type(vector), intent(in) :: v 
    complex(kind=omega_prec), intent(in) :: g 
    phi = psibar * f_vrf (g, v, psi)
  end function svr1_ff
  pure function svr2_ff (g, psibar, phi, psi) result (v)
    type(vector) :: v
    complex(kind=omega_prec), intent(in) :: phi, g
    type(bispinor), intent(in) :: psibar, psi
    v = phi * vr_ff (g, psibar, psi)
  end function svr2_ff
  pure function svlr1_ff (gl, gr, psibar, v, psi) result (phi)
    complex(kind=omega_prec) :: phi
    type(bispinor), intent(in) :: psibar, psi
    type(vector), intent(in) :: v 
    complex(kind=omega_prec), intent(in) :: gl, gr 
    phi = psibar * f_vlrf (gl, gr, v, psi)
  end function svlr1_ff
  pure function svlr2_ff (gl, gr, psibar, phi, psi) result (v)
    type(vector) :: v
    complex(kind=omega_prec), intent(in) :: phi, gl, gr
    type(bispinor), intent(in) :: psibar, psi
    v = phi * vlr_ff (gl, gr, psibar, psi)
  end function svlr2_ff
  pure function f_s2f (g, phi1, phi2, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: g, phi1, phi2 
    type(bispinor), intent(in) :: psi
    phipsi = phi1 * f_pf (g, phi2, psi) 
  end function f_s2f 
  pure function f_v2f (g, v1, v2, psi) result (vpsi)
    type(bispinor) :: vpsi
    complex(kind=omega_prec), intent(in) :: g 
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v1, v2
    vpsi = g * f_vvf (v2, psi, v1) 
  end function f_v2f 
  pure function f_svf (g, phi, v, psi) result (pvpsi)
    type(bispinor) :: pvpsi
    complex(kind=omega_prec), intent(in) :: g, phi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    pvpsi = phi * f_vf (g, v, psi)
  end function f_svf 
  pure function f_pvf (g, phi, v, psi) result (pvpsi)
    type(bispinor) :: pvpsi
    complex(kind=omega_prec), intent(in) :: g, phi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    pvpsi = -(phi * f_af (g, v, psi))
  end function f_pvf 
  pure function f_svlf (g, phi, v, psi) result (pvpsi)
    type(bispinor) :: pvpsi
    complex(kind=omega_prec), intent(in) :: g, phi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    pvpsi = phi * f_vlf (g, v, psi)
  end function f_svlf 
  pure function f_svrf (g, phi, v, psi) result (pvpsi)
    type(bispinor) :: pvpsi
    complex(kind=omega_prec), intent(in) :: g, phi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    pvpsi = phi * f_vrf (g, v, psi)
  end function f_svrf 
  pure function f_svlrf (gl, gr, phi, v, psi) result (pvpsi)
    type(bispinor) :: pvpsi
    complex(kind=omega_prec), intent(in) :: gl, gr, phi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    pvpsi = phi * f_vlrf (gl, gr, v, psi)
  end function f_svlrf 
  pure function pot_grf (g, gravbar, psi) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi 
    type(vectorspinor) :: gamma_psi
    gamma_psi%psi(1)%a(1) = psi%a(4) 
    gamma_psi%psi(1)%a(2) = - psi%a(3)
    gamma_psi%psi(1)%a(3) = - psi%a(2) 
    gamma_psi%psi(1)%a(4) = psi%a(1)
    gamma_psi%psi(2)%a(1) = psi%a(3)
    gamma_psi%psi(2)%a(2) = - psi%a(4)
    gamma_psi%psi(2)%a(3) = psi%a(1)
    gamma_psi%psi(2)%a(4) = - psi%a(2)
    gamma_psi%psi(3)%a(1) = (0,1) * psi%a(3)
    gamma_psi%psi(3)%a(2) = (0,1) * psi%a(4)
    gamma_psi%psi(3)%a(3) = (0,1) * psi%a(1)
    gamma_psi%psi(3)%a(4) = (0,1) * psi%a(2)
    gamma_psi%psi(4)%a(1) = - psi%a(4)
    gamma_psi%psi(4)%a(2) = - psi%a(3)
    gamma_psi%psi(4)%a(3) = - psi%a(2)
    gamma_psi%psi(4)%a(4) = - psi%a(1)
    j = g * (gravbar * gamma_psi)
  end function pot_grf
  pure function pot_fgr (g, psibar, grav) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(bispinor) :: gamma_grav
    gamma_grav%a(1) = grav%psi(1)%a(3) - grav%psi(2)%a(4) + & 
                 ((0,1)*grav%psi(3)%a(4)) - grav%psi(4)%a(3)
    gamma_grav%a(2) = grav%psi(1)%a(4) - grav%psi(2)%a(3) + &
                 ((0,1)*grav%psi(3)%a(3)) + grav%psi(4)%a(4)
    gamma_grav%a(3) = grav%psi(1)%a(1) + grav%psi(2)%a(2) - &
                 ((0,1)*grav%psi(3)%a(2)) + grav%psi(4)%a(1)
    gamma_grav%a(4) = grav%psi(1)%a(2) + grav%psi(2)%a(1) + &
                 ((0,1)*grav%psi(3)%a(1)) - grav%psi(4)%a(2)
    j = g * (psibar * gamma_grav)
  end function pot_fgr 
  pure function grvgf (gravbar, psi, k) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec) :: kp, km, k12, k12s
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: k
    type(vectorspinor) :: kg_psi
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2) 
    kg_psi%psi(1)%a(1) = - k12 * psi%a(1) + kp * psi%a(2) 
    kg_psi%psi(1)%a(2) = - km * psi%a(1) + k12s * psi%a(2)
    kg_psi%psi(1)%a(3) = - k12 * psi%a(3) - km * psi%a(4)
    kg_psi%psi(1)%a(4) = kp * psi%a(3) + k12s * psi%a(4)
    kg_psi%psi(2)%a(1) = - kp * psi%a(1) + k12 * psi%a(2)
    kg_psi%psi(2)%a(2) = - k12s * psi%a(1) + km * psi%a(2)
    kg_psi%psi(2)%a(3) = - km * psi%a(3) - k12 * psi%a(4)
    kg_psi%psi(2)%a(4) = k12s * psi%a(3) + kp * psi%a(4)
    kg_psi%psi(3)%a(1) = (0,1) * (- kp * psi%a(1) - k12 * psi%a(2))
    kg_psi%psi(3)%a(2) = (0,1) * (- k12s * psi%a(1) - km * psi%a(2))
    kg_psi%psi(3)%a(3) = (0,1) * (- km * psi%a(3) + k12 * psi%a(4))
    kg_psi%psi(3)%a(4) = (0,1) * (k12s * psi%a(3) - kp * psi%a(4))
    kg_psi%psi(4)%a(1) = k12 * psi%a(1) + kp * psi%a(2)
    kg_psi%psi(4)%a(2) = km * psi%a(1) + k12s * psi%a(2)
    kg_psi%psi(4)%a(3) = - k12 * psi%a(3) + km * psi%a(4)
    kg_psi%psi(4)%a(4) = kp * psi%a(3) - k12s * psi%a(4) 
    j = gravbar * kg_psi
  end function grvgf  
  pure function grg5vgf (gravbar, psi, k) result (j)
    complex(kind=omega_prec) :: j
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: k
    type(bispinor) :: g5_psi
    g5_psi%a(1:2) = - psi%a(1:2)
    g5_psi%a(3:4) =   psi%a(3:4)
    j = grvgf (gravbar, g5_psi, k)
  end function grg5vgf
  pure function s_grf (g, gravbar, psi, k) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k 
    j = g * grvgf (gravbar, psi, vk)
  end function s_grf
  pure function fgkgr (psibar, grav, k) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec) :: kp, km, k12, k12s
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(vector), intent(in) :: k
    type(bispinor) :: gk_grav
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2) 
    gk_grav%a(1) =  k12 * grav%psi(1)%a(1) + km * grav%psi(1)%a(2) &
                  - kp * grav%psi(2)%a(1) - k12s * grav%psi(2)%a(2) &
                  - (0,1) * kp * grav%psi(3)%a(1)   &
                  - (0,1) * k12s * grav%psi(3)%a(2) &
                  + k12 * grav%psi(4)%a(1) + km * grav%psi(4)%a(2) 
    gk_grav%a(2) = - kp * grav%psi(1)%a(1) - k12s * grav%psi(1)%a(2) &
                  + k12 * grav%psi(2)%a(1) + km * grav%psi(2)%a(2) &
                  - (0,1) * k12 * grav%psi(3)%a(1) &
                  - (0,1) * km * grav%psi(3)%a(2)  &
                  + kp * grav%psi(4)%a(1) + k12s * grav%psi(4)%a(2)
    gk_grav%a(3) = k12 * grav%psi(1)%a(3) - kp * grav%psi(1)%a(4) &
                  - km * grav%psi(2)%a(3) + k12s * grav%psi(2)%a(4) &
                  - (0,1) * km * grav%psi(3)%a(3)   &
                  + (0,1) * k12s * grav%psi(3)%a(4) & 
                  - k12 * grav%psi(4)%a(3) + kp * grav%psi(4)%a(4)
    gk_grav%a(4) = km * grav%psi(1)%a(3) - k12s * grav%psi(1)%a(4) &
                  - k12 * grav%psi(2)%a(3) + kp * grav%psi(2)%a(4) &
                  + (0,1) * k12 * grav%psi(3)%a(3) &
                  - (0,1) * kp * grav%psi(3)%a(4)  &
                  + km * grav%psi(4)%a(3) - k12s * grav%psi(4)%a(4)
    j = psibar * gk_grav
  end function fgkgr
  pure function fg5gkgr (psibar, grav, k) result (j)
    complex(kind=omega_prec) :: j
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(vector), intent(in) :: k
    type(bispinor) :: psibar_g5
    psibar_g5%a(1:2) = - psibar%a(1:2)
    psibar_g5%a(3:4) =   psibar%a(3:4)
    j = fgkgr (psibar_g5, grav, k)
  end function fg5gkgr
  pure function s_fgr (g, psibar, grav, k) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k 
    j = g * fgkgr (psibar, grav, vk)
  end function s_fgr
  pure function p_grf (g, gravbar, psi, k) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k 
    j = g * grg5vgf (gravbar, psi, vk)
  end function p_grf
  pure function p_fgr (g, psibar, grav, k) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k 
    j = g * fg5gkgr (psibar, grav, vk)
  end function p_fgr
  pure function f_potgr (g, phi, psi) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi
    type(vectorspinor), intent(in) :: psi
    phipsi%a(1) = (g * phi) * (psi%psi(1)%a(3) - psi%psi(2)%a(4) + & 
                   ((0,1)*psi%psi(3)%a(4)) - psi%psi(4)%a(3))
    phipsi%a(2) = (g * phi) * (psi%psi(1)%a(4) - psi%psi(2)%a(3) - &
                   ((0,1)*psi%psi(3)%a(3)) + psi%psi(4)%a(4)) 
    phipsi%a(3) = (g * phi) * (psi%psi(1)%a(1) + psi%psi(2)%a(2) - &
                   ((0,1)*psi%psi(3)%a(2)) + psi%psi(4)%a(1))
    phipsi%a(4) = (g * phi) * (psi%psi(1)%a(2) + psi%psi(2)%a(1) + &
                   ((0,1)*psi%psi(3)%a(1)) - psi%psi(4)%a(2))
  end function f_potgr 
  pure function fgvgr (psi, k) result (kpsi)
    type(bispinor) :: kpsi
    complex(kind=omega_prec) :: kp, km, k12, k12s
    type(vector), intent(in) :: k
    type(vectorspinor), intent(in) :: psi
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2) 
    kpsi%a(1) = kp * psi%psi(1)%a(1) + k12s * psi%psi(1)%a(2) &
          - k12 * psi%psi(2)%a(1) - km * psi%psi(2)%a(2) &
          + (0,1) * k12 * psi%psi(3)%a(1) + (0,1) * km * psi%psi(3)%a(2) &
          - kp * psi%psi(4)%a(1) - k12s * psi%psi(4)%a(2)
    kpsi%a(2) = k12 * psi%psi(1)%a(1) + km * psi%psi(1)%a(2) &
          - kp * psi%psi(2)%a(1) - k12s * psi%psi(2)%a(2) &
          - (0,1) * kp * psi%psi(3)%a(1) - (0,1) * k12s * psi%psi(3)%a(2) &
          + k12 * psi%psi(4)%a(1) + km * psi%psi(4)%a(2)
    kpsi%a(3) = km * psi%psi(1)%a(3) - k12s * psi%psi(1)%a(4) &
          - k12 * psi%psi(2)%a(3) + kp * psi%psi(2)%a(4) &
          + (0,1) * k12 * psi%psi(3)%a(3) - (0,1) * kp * psi%psi(3)%a(4) &
          + k12 * psi%psi(4)%a(3) - kp * psi%psi(4)%a(4)
    kpsi%a(4) = - k12 * psi%psi(1)%a(3) + kp * psi%psi(1)%a(4) &
          + km * psi%psi(2)%a(3) - k12s * psi%psi(2)%a(4) &
          + (0,1) * km * psi%psi(3)%a(3) - (0,1) * k12s * psi%psi(3)%a(4) &
          + k12 * psi%psi(4)%a(3) - kp * psi%psi(4)%a(4)
  end function fgvgr
  pure function f_sgr (g, phi, psi, k) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi
    type(momentum), intent(in) :: k
    type(vectorspinor), intent(in) :: psi
    type(vector) :: vk
    vk = k 
    phipsi = (g * phi) * fgvgr (psi, vk)
  end function f_sgr 
  pure function fgvg5gr (psi, k) result (kpsi)
    type(bispinor) :: kpsi
    type(vector), intent(in) :: k
    type(vectorspinor), intent(in) :: psi
    type(bispinor) :: kpsi_dum
    kpsi_dum = fgvgr (psi, k)
    kpsi%a(1:2) = - kpsi_dum%a(1:2)
    kpsi%a(3:4) =   kpsi_dum%a(3:4)
  end function fgvg5gr
  pure function f_pgr (g, phi, psi, k) result (phipsi)
    type(bispinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi
    type(momentum), intent(in) :: k
    type(vectorspinor), intent(in) :: psi
    type(vector) :: vk
    vk = k
    phipsi = (g * phi) * fgvg5gr (psi, vk)
  end function f_pgr
  pure function fggvvgr (v, psi, k) result (psikv)
    type(bispinor) :: psikv
    type(vectorspinor), intent(in) :: psi
    type(vector), intent(in) :: v, k
    complex(kind=omega_prec) :: kv30, kv21, kv01, kv31, kv02, kv32
    complex(kind=omega_prec) :: ap, am, bp, bm, bps, bms
    kv30 = k%x(3) * v%t - k%t * v%x(3)
    kv21 = (0,1) * (k%x(2) * v%x(1) - k%x(1) * v%x(2))
    kv01 = k%t * v%x(1) - k%x(1) * v%t
    kv31 = k%x(3) * v%x(1) - k%x(1) * v%x(3)
    kv02 = (0,1) * (k%t * v%x(2) - k%x(2) * v%t)
    kv32 = (0,1) * (k%x(3) * v%x(2) - k%x(2) * v%x(3))
    ap  = 2 * (kv30 + kv21)
    am  = 2 * (-kv30 + kv21)
    bp  = 2 * (kv01 + kv31 + kv02 + kv32)
    bm  = 2 * (kv01 - kv31 + kv02 - kv32) 
    bps = 2 * (kv01 + kv31 - kv02 - kv32) 
    bms = 2 * (kv01 - kv31 - kv02 + kv32)
    psikv%a(1) =  -ap * psi%psi(1)%a(3) + bps * psi%psi(1)%a(4) &
                  - bm * psi%psi(2)%a(3) - ap * psi%psi(2)%a(4) &
                  + (0,1) * (bm * psi%psi(3)%a(3) + ap * psi%psi(3)%a(4)) &
                  + ap * psi%psi(4)%a(3) - bps * psi%psi(4)%a(4)
    psikv%a(2) =  bm * psi%psi(1)%a(3) + ap * psi%psi(1)%a(4) &
                  + ap * psi%psi(2)%a(3) - bps * psi%psi(2)%a(4) &
                  + (0,1) * (ap * psi%psi(3)%a(3) - bps * psi%psi(3)%a(4)) &
                  + bm * psi%psi(4)%a(3) + ap * psi%psi(4)%a(4)
    psikv%a(3) =  am * psi%psi(1)%a(1) + bms * psi%psi(1)%a(2) &
                  + bp * psi%psi(2)%a(1) - am * psi%psi(2)%a(2) &
                  - (0,1) * (bp * psi%psi(3)%a(1) - am * psi%psi(3)%a(2)) &
                  + am * psi%psi(4)%a(1) + bms * psi%psi(4)%a(2)
    psikv%a(4) =  bp * psi%psi(1)%a(1) - am * psi%psi(1)%a(2) &
                  + am * psi%psi(2)%a(1) + bms * psi%psi(2)%a(2) &
                  + (0,1) * (am * psi%psi(3)%a(1) + bms * psi%psi(3)%a(2)) &
                  - bp * psi%psi(4)%a(1) + am * psi%psi(4)%a(2)
  end function fggvvgr
  pure function f_vgr (g, v, psi, k) result (psikv)
    type(bispinor) :: psikv
    type(vectorspinor), intent(in) :: psi
    type(vector), intent(in) :: v
    type(momentum), intent(in) :: k
    complex(kind=omega_prec), intent(in) :: g
    type(vector) :: vk
    vk = k 
    psikv = g * fggvvgr (v, psi, vk)
  end function f_vgr
  pure function gr_potf (g, phi, psi) result (phipsi)
    type(vectorspinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    phipsi%psi(1)%a(1) = (g * phi) * psi%a(3)
    phipsi%psi(1)%a(2) = (g * phi) * psi%a(4)
    phipsi%psi(1)%a(3) = (g * phi) * psi%a(1)
    phipsi%psi(1)%a(4) = (g * phi) * psi%a(2)
    phipsi%psi(2)%a(1) = (g * phi) * psi%a(4)
    phipsi%psi(2)%a(2) = (g * phi) * psi%a(3)
    phipsi%psi(2)%a(3) = (- g * phi) * psi%a(2)
    phipsi%psi(2)%a(4) = (- g * phi) * psi%a(1)
    phipsi%psi(3)%a(1) = (- (0, 1) * g * phi) * psi%a(4)
    phipsi%psi(3)%a(2) = ((0, 1) * g * phi) * psi%a(3)
    phipsi%psi(3)%a(3) = ((0, 1) * g * phi) * psi%a(2)
    phipsi%psi(3)%a(4) = (- (0, 1) * g * phi) * psi%a(1)
    phipsi%psi(4)%a(1) = (g * phi) * psi%a(3)
    phipsi%psi(4)%a(2) = (- g * phi) * psi%a(4)
    phipsi%psi(4)%a(3) = (- g * phi) * psi%a(1)
    phipsi%psi(4)%a(4) = (g * phi) * psi%a(2)
  end function gr_potf 
  pure function grkgf (psi, k) result (kpsi)
    type(vectorspinor) :: kpsi
    complex(kind=omega_prec) :: kp, km, k12, k12s
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: k
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2) 
    kpsi%psi(1)%a(1) = km * psi%a(1) - k12s * psi%a(2)
    kpsi%psi(1)%a(2) = - k12 * psi%a(1) + kp * psi%a(2)
    kpsi%psi(1)%a(3) = kp * psi%a(3) + k12s * psi%a(4)
    kpsi%psi(1)%a(4) = k12 * psi%a(3) + km * psi%a(4)
    kpsi%psi(2)%a(1) = k12s * psi%a(1) - km * psi%a(2)
    kpsi%psi(2)%a(2) = - kp * psi%a(1) + k12 * psi%a(2)
    kpsi%psi(2)%a(3) = k12s * psi%a(3) + kp * psi%a(4)
    kpsi%psi(2)%a(4) = km * psi%a(3) + k12 * psi%a(4)
    kpsi%psi(3)%a(1) = (0,1) * (k12s * psi%a(1) + km * psi%a(2))
    kpsi%psi(3)%a(2) = (0,-1) * (kp * psi%a(1) + k12 * psi%a(2))
    kpsi%psi(3)%a(3) = (0,1) * (k12s * psi%a(3) - kp * psi%a(4))
    kpsi%psi(3)%a(4) = (0,1) * (km * psi%a(3) - k12 * psi%a(4))
    kpsi%psi(4)%a(1) = -(km * psi%a(1) + k12s * psi%a(2))
    kpsi%psi(4)%a(2) = k12 * psi%a(1) + kp * psi%a(2)
    kpsi%psi(4)%a(3) = kp * psi%a(3) - k12s * psi%a(4)
    kpsi%psi(4)%a(4) = k12 * psi%a(3) - km * psi%a(4)
  end function grkgf
  pure function gr_sf (g, phi, psi, k) result (phipsi)
    type(vectorspinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k 
    phipsi = (g * phi) * grkgf (psi, vk)
  end function gr_sf
  pure function grkggf (psi, k) result (kpsi)
    type(vectorspinor) :: kpsi
    complex(kind=omega_prec) :: kp, km, k12, k12s
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: k
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2) 
    kpsi%psi(1)%a(1) = - km * psi%a(1) + k12s * psi%a(2)
    kpsi%psi(1)%a(2) = k12 * psi%a(1) - kp * psi%a(2)
    kpsi%psi(1)%a(3) = kp * psi%a(3) + k12s * psi%a(4)
    kpsi%psi(1)%a(4) = k12 * psi%a(3) + km * psi%a(4)
    kpsi%psi(2)%a(1) = - k12s * psi%a(1) + km * psi%a(2)
    kpsi%psi(2)%a(2) = kp * psi%a(1) - k12 * psi%a(2)
    kpsi%psi(2)%a(3) = k12s * psi%a(3) + kp * psi%a(4)
    kpsi%psi(2)%a(4) = km * psi%a(3) + k12 * psi%a(4)
    kpsi%psi(3)%a(1) = (0,-1) * (k12s * psi%a(1) + km * psi%a(2))
    kpsi%psi(3)%a(2) = (0,1) * (kp * psi%a(1) + k12 * psi%a(2))
    kpsi%psi(3)%a(3) = (0,1) * (k12s * psi%a(3) - kp * psi%a(4))
    kpsi%psi(3)%a(4) = (0,1) * (km * psi%a(3) - k12 * psi%a(4))
    kpsi%psi(4)%a(1) = km * psi%a(1) + k12s * psi%a(2)
    kpsi%psi(4)%a(2) = -(k12 * psi%a(1) + kp * psi%a(2))
    kpsi%psi(4)%a(3) = kp * psi%a(3) - k12s * psi%a(4)
    kpsi%psi(4)%a(4) = k12 * psi%a(3) - km * psi%a(4)
  end function grkggf
  pure function gr_pf (g, phi, psi, k) result (phipsi)
    type(vectorspinor) :: phipsi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi
    type(bispinor), intent(in) :: psi
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k
    phipsi = (g * phi) * grkggf (psi, vk) 
  end function gr_pf 
  pure function grkkggf (v, psi, k) result (psikv)
    type(vectorspinor) :: psikv
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v, k
    complex(kind=omega_prec) :: kv30, kv21, kv01, kv31, kv02, kv32
    complex(kind=omega_prec) :: ap, am, bp, bm, bps, bms
    kv30 = k%x(3) * v%t - k%t * v%x(3)
    kv21 = (0,1) * (k%x(2) * v%x(1) - k%x(1) * v%x(2))
    kv01 = k%t * v%x(1) - k%x(1) * v%t
    kv31 = k%x(3) * v%x(1) - k%x(1) * v%x(3)
    kv02 = (0,1) * (k%t * v%x(2) - k%x(2) * v%t)
    kv32 = (0,1) * (k%x(3) * v%x(2) - k%x(2) * v%x(3))
    ap  = 2 * (kv30 + kv21)
    am  = 2 * (-kv30 + kv21)
    bp  = 2 * (kv01 + kv31 + kv02 + kv32)
    bm  = 2 * (kv01 - kv31 + kv02 - kv32) 
    bps = 2 * (kv01 + kv31 - kv02 - kv32) 
    bms = 2 * (kv01 - kv31 - kv02 + kv32)
    psikv%psi(1)%a(1) = am * psi%a(3) + bms * psi%a(4)
    psikv%psi(1)%a(2) = bp * psi%a(3) - am * psi%a(4)
    psikv%psi(1)%a(3) = -ap * psi%a(1) + bps * psi%a(2)
    psikv%psi(1)%a(4) = bm * psi%a(1) + ap * psi%a(2)
    psikv%psi(2)%a(1) = bms * psi%a(3) + am * psi%a(4)
    psikv%psi(2)%a(2) = -am * psi%a(3) + bp * psi%a(4)
    psikv%psi(2)%a(3) = -bps * psi%a(1) + ap * psi%a(2)
    psikv%psi(2)%a(4) = ap * psi%a(1) + bm * psi%a(2)
    psikv%psi(3)%a(1) = (0,1) * (bms * psi%a(3) - am * psi%a(4)) 
    psikv%psi(3)%a(2) = (0,-1) * (am * psi%a(3) + bp * psi%a(4))
    psikv%psi(3)%a(3) = (0,-1) * (bps * psi%a(1) + ap * psi%a(2))
    psikv%psi(3)%a(4) = (0,1) * (-ap * psi%a(1) + bm * psi%a(2))
    psikv%psi(4)%a(1) = am * psi%a(3) - bms * psi%a(4)
    psikv%psi(4)%a(2) = bp * psi%a(3) + am * psi%a(4) 
    psikv%psi(4)%a(3) = ap * psi%a(1) + bps * psi%a(2)
    psikv%psi(4)%a(4) = -bm * psi%a(1) + ap * psi%a(2) 
  end function grkkggf
  pure function gr_vf (g, v, psi, k) result (psikv)
    type(vectorspinor) :: psikv
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    type(momentum), intent(in) :: k
    complex(kind=omega_prec), intent(in) :: g
    type(vector) :: vk
    vk = k 
    psikv = g * grkkggf (v, psi, vk)
  end function gr_vf
  pure function grkgggf (psil, psir, k) result (j)
    type(vector) :: j
    type(vectorspinor), intent(in) :: psil
    type(bispinor), intent(in) :: psir
    type(vector), intent(in) :: k
    type(vectorspinor) :: c_psir0, c_psir1, c_psir2, c_psir3
    complex(kind=omega_prec) :: kp, km, k12, k12s, ik2
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2) 
    ik2 = (0,1) * k%x(2)
    c_psir0%psi(1)%a(1) = - k12 * psir%a(3) - k%x(3) * psir%a(4)
    c_psir0%psi(1)%a(2) = k%x(3) * psir%a(3) + k12s * psir%a(4)
    c_psir0%psi(1)%a(3) = k12 * psir%a(1) - k%x(3) * psir%a(2)
    c_psir0%psi(1)%a(4) = - k%x(3) * psir%a(1) - k12s * psir%a(2)
    c_psir0%psi(2)%a(1) = k%x(3) * psir%a(3) - k12 * psir%a(4)
    c_psir0%psi(2)%a(2) = k12s * psir%a(3) + k%x(3) * psir%a(4)
    c_psir0%psi(2)%a(3) = k%x(3) * psir%a(1) - k12 * psir%a(2)
    c_psir0%psi(2)%a(4) = k12s * psir%a(1) + k%x(3) * psir%a(2)
    c_psir0%psi(3)%a(1) = (0,1) * (k%x(3) * psir%a(3) + k12 * psir%a(4))
    c_psir0%psi(3)%a(2) = (0,1) * (k12s * psir%a(3) - k%x(3) * psir%a(4))
    c_psir0%psi(3)%a(3) = (0,1) * (k%x(3) * psir%a(1) + k12 * psir%a(2))
    c_psir0%psi(3)%a(4) = (0,1) * (k12s * psir%a(1) - k%x(3) * psir%a(2))
    c_psir0%psi(4)%a(1) = -k12 * psir%a(3) - k%x(3) * psir%a(4)
    c_psir0%psi(4)%a(2) = k%x(3) * psir%a(3) - k12s * psir%a(4)
    c_psir0%psi(4)%a(3) = -k12 * psir%a(1) - k%x(3) * psir%a(2) 
    c_psir0%psi(4)%a(4) = k%x(3) * psir%a(1) - k12s * psir%a(2)
    c_psir1%psi(1)%a(1) = -kp * psir%a(3) + ik2 * psir%a(4)
    c_psir1%psi(1)%a(2) = ik2 * psir%a(3) + km * psir%a(4)
    c_psir1%psi(1)%a(3) = km * psir%a(1) + ik2 * psir%a(2)
    c_psir1%psi(1)%a(4) = ik2 * psir%a(1) - kp * psir%a(2) 
    c_psir1%psi(2)%a(1) = ik2 * psir%a(3) - kp * psir%a(4)
    c_psir1%psi(2)%a(2) = km * psir%a(3) + ik2 * psir%a(4)
    c_psir1%psi(2)%a(3) = -ik2 * psir%a(1) - km * psir%a(2)
    c_psir1%psi(2)%a(4) = kp * psir%a(1) - ik2 * psir%a(2)
    c_psir1%psi(3)%a(1) = -k%x(2) * psir%a(3) + ((0,1) * kp) * psir%a(4)
    c_psir1%psi(3)%a(2) = ((0,1) * km) * psir%a(3) + k%x(2) * psir%a(4)
    c_psir1%psi(3)%a(3) = k%x(2) * psir%a(1) + ((0,1) * km) * psir%a(2)
    c_psir1%psi(3)%a(4) = ((0,1) * kp) * psir%a(1) - k%x(2) * psir%a(2)
    c_psir1%psi(4)%a(1) = -kp * psir%a(3) - ik2 * psir%a(4)
    c_psir1%psi(4)%a(2) = ik2 * psir%a(3) - km * psir%a(4)
    c_psir1%psi(4)%a(3) = -km * psir%a(1) + ik2 * psir%a(2)
    c_psir1%psi(4)%a(4) = -ik2 *  psir%a(1) - kp * psir%a(2) 
    c_psir2%psi(1)%a(1) = (0,-1) * (kp * psir%a(3) + k%x(1) * psir%a(4))
    c_psir2%psi(1)%a(2) = (0,-1) * (k%x(1) * psir%a(3) + km * psir%a(4))  
    c_psir2%psi(1)%a(3) = (0,1) * (km * psir%a(1) - k%x(1) * psir%a(2))
    c_psir2%psi(1)%a(4) = (0,1) * (-k%x(1) * psir%a(1) + kp * psir%a(2)) 
    c_psir2%psi(2)%a(1) = (0,-1) * (k%x(1) * psir%a(3) + kp * psir%a(4))
    c_psir2%psi(2)%a(2) = (0,-1) * (km * psir%a(3) + k%x(1) * psir%a(4))
    c_psir2%psi(2)%a(3) = (0,1) * (k%x(1) * psir%a(1) - km * psir%a(2))
    c_psir2%psi(2)%a(4) = (0,1) * (- kp * psir%a(1) + k%x(1) * psir%a(2))
    c_psir2%psi(3)%a(1) = k%x(1) * psir%a(3) - kp * psir%a(4)
    c_psir2%psi(3)%a(2) = km * psir%a(3) - k%x(1) * psir%a(4)
    c_psir2%psi(3)%a(3) = - k%x(1) * psir%a(1) - km * psir%a(2)
    c_psir2%psi(3)%a(4) = kp * psir%a(1) + k%x(1) * psir%a(2) 
    c_psir2%psi(4)%a(1) = (0,1) * (-kp * psir%a(3) + k%x(1) * psir%a(4))
    c_psir2%psi(4)%a(2) = (0,1) * (-k%x(1) * psir%a(3) + km * psir%a(4))
    c_psir2%psi(4)%a(3) = (0,-1) * (km * psir%a(1) + k%x(1) * psir%a(2))
    c_psir2%psi(4)%a(4) = (0,1) * (k%x(1) * psir%a(1) + kp * psir%a(2))
    c_psir3%psi(1)%a(1) = k12 * psir%a(3) + k%t * psir%a(4)
    c_psir3%psi(1)%a(2) = k%t * psir%a(3) + k12s * psir%a(4)
    c_psir3%psi(1)%a(3) = k12 * psir%a(1) - k%t * psir%a(2) 
    c_psir3%psi(1)%a(4) = -k%t * psir%a(1) + k12s * psir%a(2)
    c_psir3%psi(2)%a(1) = k%t * psir%a(3) + k12 * psir%a(4)
    c_psir3%psi(2)%a(2) = k12s * psir%a(3) + k%t * psir%a(4)
    c_psir3%psi(2)%a(3) = k%t * psir%a(1) - k12 * psir%a(2)
    c_psir3%psi(2)%a(4) = -k12s * psir%a(1) + k%t * psir%a(2) 
    c_psir3%psi(3)%a(1) = (0,1) * (k%t * psir%a(3) - k12 * psir%a(4))
    c_psir3%psi(3)%a(2) = (0,1) * (k12s * psir%a(3) - k%t * psir%a(4)) 
    c_psir3%psi(3)%a(3) = (0,1) * (k%t * psir%a(1) + k12 * psir%a(2))
    c_psir3%psi(3)%a(4) = (0,-1) * (k12s * psir%a(1) + k%t * psir%a(2))
    c_psir3%psi(4)%a(1) = k12 * psir%a(3) - k%t * psir%a(4)
    c_psir3%psi(4)%a(2) = k%t * psir%a(3) - k12s * psir%a(4)
    c_psir3%psi(4)%a(3) = -k12 * psir%a(1) - k%t * psir%a(2)
    c_psir3%psi(4)%a(4) = k%t * psir%a(1) + k12s * psir%a(2) 
    j%t    =   2 * (psil * c_psir0) 
    j%x(1) =   2 * (psil * c_psir1)
    j%x(2) =   2 * (psil * c_psir2)
    j%x(3) =   2 * (psil * c_psir3)
  end function grkgggf
  pure function v_grf (g, psil, psir, k) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: psil
    type(bispinor), intent(in) :: psir
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k 
    j = g * grkgggf (psil, psir, vk)
  end function v_grf
  pure function fggkggr (psil, psir, k) result (j)
    type(vector) :: j
    type(vectorspinor), intent(in) :: psir
    type(bispinor), intent(in) :: psil
    type(vector), intent(in) :: k
    type(bispinor) :: c_psir0, c_psir1, c_psir2, c_psir3
    complex(kind=omega_prec) :: kp, km, k12, k12s, ik1, ik2
    kp = k%t + k%x(3)
    km = k%t - k%x(3)
    k12  =  k%x(1) + (0,1)*k%x(2)
    k12s =  k%x(1) - (0,1)*k%x(2) 
    ik1 = (0,1) * k%x(1)
    ik2 = (0,1) * k%x(2)
    c_psir0%a(1) = k%x(3) * (psir%psi(1)%a(4) + psir%psi(4)%a(4) &
                  + psir%psi(2)%a(3) + (0,1) * psir%psi(3)%a(3)) - &  
                  k12 * (psir%psi(1)%a(3) + psir%psi(4)%a(4)) + & 
                  k12s * (psir%psi(2)%a(4) + (0,1) * psir%psi(3)%a(4)) 
    c_psir0%a(2) = k%x(3) * (psir%psi(1)%a(3) - psir%psi(4)%a(3) + &
                  psir%psi(2)%a(4) - (0,1) * psir%psi(3)%a(4)) + &
                  k12s * (psir%psi(1)%a(4) - psir%psi(4)%a(4)) - &
                  k12 * (psir%psi(2)%a(3) + (0,1) * psir%psi(3)%a(3))
    c_psir0%a(3) = k%x(3) * (-psir%psi(1)%a(2) + psir%psi(4)%a(2) + &
                  psir%psi(2)%a(1) + (0,1) * psir%psi(3)%a(2)) + &
                  k12 * (psir%psi(1)%a(1) - psir%psi(4)%a(1)) + &
                  k12s * (psir%psi(2)%a(2) + psir%psi(3)%a(2))
    c_psir0%a(4) = k%x(3) * (-psir%psi(1)%a(1) - psir%psi(4)%a(1) + &
                  psir%psi(2)%a(2) - (0,1) * psir%psi(3)%a(2)) -  &
                  k12s * (psir%psi(1)%a(2) + psir%psi(4)%a(1)) - &
                  k12 * (psir%psi(2)%a(1) - psir%psi(3)%a(1))
    c_psir1%a(1) = ik2 * (-psir%psi(1)%a(4) - psir%psi(4)%a(4) - & 
                  psir%psi(2)%a(3) - (0,1) * psir%psi(3)%a(3)) - & 
                  km * (psir%psi(1)%a(3) + psir%psi(4)%a(3)) + & 
                  kp * (psir%psi(2)%a(4) + (0,1) * psir%psi(3)%a(4))
    c_psir1%a(2) = ik2 * (-psir%psi(1)%a(3) - psir%psi(2)%a(4) + &
                  psir%psi(4)%a(3) + (0,1) * psir%psi(3)%a(4)) + &
                  kp * (psir%psi(1)%a(4) - psir%psi(4)%a(4)) - &
                  km * (psir%psi(2)%a(3) - (0,1) * psir%psi(3)%a(3))
    c_psir1%a(3) = ik2 * (-psir%psi(1)%a(2) + psir%psi(2)%a(1) + &
                  psir%psi(4)%a(2) + (0,1) * psir%psi(3)%a(1)) + &
                  kp * (psir%psi(1)%a(1) - psir%psi(4)%a(1)) + &
                  km * (psir%psi(2)%a(2) + (0,1) * psir%psi(3)%a(2))
    c_psir1%a(4) = ik2 * (-psir%psi(1)%a(1) + psir%psi(2)%a(2) - &
                  psir%psi(4)%a(1) - (0,1) * psir%psi(3)%a(2)) - &
                  km * (psir%psi(1)%a(2) + psir%psi(4)%a(2)) - &
                  kp * (psir%psi(2)%a(1) - (0,1) * psir%psi(3)%a(1))
    c_psir2%a(1) = ik1 * (psir%psi(2)%a(3) - psir%psi(1)%a(4) & 
                  + psir%psi(4)%a(4) + (0,1) * psir%psi(3)%a(3)) - &
                  ((0,1)*km) * (psir%psi(1)%a(3) + psir%psi(4)%a(3)) &
                  + kp * (psir%psi(3)%a(4) - (0,1) * psir%psi(2)%a(4)) 
    c_psir2%a(2) = ik1 * (psir%psi(1)%a(3) + psir%psi(2)%a(4) - &
                  psir%psi(4)%a(3) - (0,1) * psir%psi(3)%a(4)) - &
                  ((0,1)*kp) * (psir%psi(1)%a(4) - psir%psi(4)%a(4)) &
                  - km * (psir%psi(3)%a(3) + (0,1) * psir%psi(2)%a(3))
    c_psir2%a(3) = ik1 * (psir%psi(1)%a(2) - psir%psi(2)%a(1) - &
                  psir%psi(4)%a(2) - (0,1) * psir%psi(3)%a(1)) + &
                  ((0,1)*kp) * (psir%psi(1)%a(1) - psir%psi(4)%a(1)) &
                  + km * (psir%psi(3)%a(2) - (0,1) * psir%psi(2)%a(2))
    c_psir2%a(4) = ik1 * (psir%psi(1)%a(1) - psir%psi(2)%a(2) + &
                  psir%psi(4)%a(1) + (0,1) * psir%psi(3)%a(2)) + &
                  ((0,1)*km) * (psir%psi(1)%a(2) + psir%psi(4)%a(2)) - &
                  kp * (psir%psi(3)%a(1) + (0,1) * psir%psi(2)%a(1))
    c_psir3%a(1) = k%t * (psir%psi(1)%a(4) + psir%psi(4)%a(4) + &
                  psir%psi(2)%a(3) + (0,1) * psir%psi(3)%a(3)) - &
                  k12 * (psir%psi(1)%a(3) + psir%psi(4)%a(3)) - &
                  k12s * (psir%psi(2)%a(4) - (0,1) * psir%psi(3)%a(4))
    c_psir3%a(2) = k%t * (psir%psi(1)%a(3) - psir%psi(4)%a(3) + & 
                  psir%psi(2)%a(4) - (0,1) * psir%psi(3)%a(4)) - & 
                  k12s * (psir%psi(1)%a(4) - psir%psi(4)%a(4)) - &
                  k12 * (psir%psi(2)%a(3) - (0,1) * psir%psi(3)%a(3))
    c_psir3%a(3) = k%t * (-psir%psi(1)%a(2) + psir%psi(2)%a(1) + &
                  psir%psi(4)%a(2) + (0,1) * psir%psi(3)%a(1)) - &
                  k12 * (psir%psi(1)%a(1) - psir%psi(4)%a(1)) + &
                  k12s * (psir%psi(2)%a(2) + (0,1) * psir%psi(3)%a(2))
    c_psir3%a(4) = k%t * (-psir%psi(1)%a(1) + psir%psi(2)%a(2) - &
                  psir%psi(4)%a(1) - (0,1) * psir%psi(3)%a(2)) - &
                  k12s * (psir%psi(1)%a(2) + psir%psi(4)%a(2)) + &
                  k12 * (psir%psi(2)%a(1) - (0,1) * psir%psi(3)%a(1))
    j%t    =   2 * (psil * c_psir0) 
    j%x(1) =   2 * (psil * c_psir1)
    j%x(2) =   2 * (psil * c_psir2)
    j%x(3) =   2 * (psil * c_psir3) 
  end function fggkggr
  pure function v_fgr (g, psil, psir, k) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: psir
    type(bispinor), intent(in) :: psil
    type(momentum), intent(in) :: k
    type(vector) :: vk
    vk = k 
    j = g * fggkggr (psil, psir, vk)
  end function v_fgr
  pure function f_s2gr (g, phi1, phi2, psi) result (phipsi)
    type(bispinor) :: phipsi
    type(vectorspinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi1, phi2
    phipsi = phi2 * f_potgr (g, phi1, psi) 
  end function f_s2gr 
  pure function f_svgr (g, phi, v, grav) result (phigrav)
    type(bispinor) :: phigrav
    type(vectorspinor), intent(in) :: grav
    type(vector), intent(in) :: v
    complex(kind=omega_prec), intent(in) :: g, phi
    phigrav = (g * phi) * fgvg5gr (grav, v)
  end function f_svgr
  pure function f_pvgr (g, phi, v, grav) result (phigrav)
    type(bispinor) :: phigrav
    type(vectorspinor), intent(in) :: grav
    type(vector), intent(in) :: v
    complex(kind=omega_prec), intent(in) :: g, phi
    phigrav = (g * phi) * fgvgr (grav, v)
  end function f_pvgr
  pure function f_v2gr (g, v1, v2, grav) result (psi)
    type(bispinor) :: psi
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: grav
    type(vector), intent(in) :: v1, v2
    psi = g * fggvvgr (v2, grav, v1)
  end function f_v2gr
  pure function gr_s2f (g, phi1, phi2, psi) result (phipsi)
    type(vectorspinor) :: phipsi
    type(bispinor), intent(in) :: psi
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: phi1, phi2
    phipsi = phi2 * gr_potf (g, phi1, psi) 
  end function gr_s2f 
  pure function gr_svf (g, phi, v, psi) result (phipsi)
    type(vectorspinor) :: phipsi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    complex(kind=omega_prec), intent(in) :: g, phi
    phipsi = (g * phi) * grkggf (psi, v)
  end function gr_svf
  pure function gr_pvf (g, phi, v, psi) result (phipsi)
    type(vectorspinor) :: phipsi
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    complex(kind=omega_prec), intent(in) :: g, phi
    phipsi = (g * phi) * grkgf (psi, v)
  end function gr_pvf
  pure function gr_v2f (g, v1, v2, psi) result (vvpsi)
    type(vectorspinor) :: vvpsi
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v1, v2
    vvpsi = g * grkkggf (v2, psi, v1) 
  end function gr_v2f
  pure function s2_grf (g, gravbar, phi, psi) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g, phi
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi 
    j = phi * pot_grf (g, gravbar, psi) 
  end function s2_grf
  pure function s2_fgr (g, psibar, phi, grav) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g, phi
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav 
    j = phi * pot_fgr (g, psibar, grav) 
  end function s2_fgr
  pure function sv1_grf (g, gravbar, v, psi) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    j = g * grg5vgf (gravbar, psi, v)
  end function sv1_grf
  pure function sv2_grf (g, gravbar, phi, psi) result (j) 
    type(vector) :: j 
    complex(kind=omega_prec), intent(in) :: g, phi
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(vectorspinor) :: g0_psi, g1_psi, g2_psi, g3_psi
    g0_psi%psi(1)%a(1) = - psi%a(2) 
    g0_psi%psi(1)%a(2) = psi%a(1) 
    g0_psi%psi(1)%a(3) = - psi%a(4) 
    g0_psi%psi(1)%a(4) = psi%a(3) 
    g0_psi%psi(2)%a(1) = psi%a(1)
    g0_psi%psi(2)%a(2) = - psi%a(2)
    g0_psi%psi(2)%a(3) = - psi%a(3)
    g0_psi%psi(2)%a(4) = psi%a(4)
    g0_psi%psi(3)%a(1) = (0,1) * psi%a(1) 
    g0_psi%psi(3)%a(2) = (0,1) * psi%a(2)
    g0_psi%psi(3)%a(3) = (0,-1) * psi%a(3)
    g0_psi%psi(3)%a(4) = (0,-1) * psi%a(4)
    g0_psi%psi(4)%a(1) = - psi%a(2)
    g0_psi%psi(4)%a(2) = - psi%a(1) 
    g0_psi%psi(4)%a(3) = psi%a(4)
    g0_psi%psi(4)%a(4) = psi%a(3) 
    g1_psi%psi(1)%a(1:4) = - g0_psi%psi(2)%a(1:4)
    g1_psi%psi(2)%a(1:4) = - g0_psi%psi(1)%a(1:4)
    g1_psi%psi(3)%a(1) = (0,-1) * psi%a(2)
    g1_psi%psi(3)%a(2) = (0,-1) * psi%a(1)
    g1_psi%psi(3)%a(3) = (0,-1) * psi%a(4)
    g1_psi%psi(3)%a(4) = (0,-1) * psi%a(3) 
    g1_psi%psi(4)%a(1:4) = psi%a(1:4) 
    g2_psi%psi(1)%a(1:4) = - g0_psi%psi(3)%a(1:4)
    g2_psi%psi(2)%a(1:4) = - g1_psi%psi(3)%a(1:4)
    g2_psi%psi(3)%a(1:4) = - g0_psi%psi(1)%a(1:4)
    g2_psi%psi(4)%a(1) = (0,1) * psi%a(1)  
    g2_psi%psi(4)%a(2) = (0,-1) * psi%a(2)
    g2_psi%psi(4)%a(3) = (0,1) * psi%a(3)
    g2_psi%psi(4)%a(4) = (0,-1) * psi%a(4) 
    g3_psi%psi(1)%a(1:4) = - g0_psi%psi(4)%a(1:4)
    g3_psi%psi(2)%a(1:4) = - g1_psi%psi(4)%a(1:4)
    g3_psi%psi(3)%a(1:4) = - g2_psi%psi(4)%a(1:4)
    g3_psi%psi(4)%a(1:4) = - g0_psi%psi(1)%a(1:4) 
    j%t    =   (g * phi) * (gravbar * g0_psi) 
    j%x(1) =   (g * phi) * (gravbar * g1_psi)
    j%x(2) =   (g * phi) * (gravbar * g2_psi)
    j%x(3) =   (g * phi) * (gravbar * g3_psi) 
  end function sv2_grf
  pure function sv1_fgr (g, psibar, v, grav) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(vector), intent(in) :: v
    j = g * fg5gkgr (psibar, grav, v) 
  end function sv1_fgr
  pure function sv2_fgr (g, psibar, phi, grav) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: g, phi
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(bispinor) :: g0_grav, g1_grav, g2_grav, g3_grav
    g0_grav%a(1) = -grav%psi(1)%a(2) +  grav%psi(2)%a(1) + &
                  (0,1) * grav%psi(3)%a(1) - grav%psi(4)%a(2)
    g0_grav%a(2) = grav%psi(1)%a(1) - grav%psi(2)%a(2) + &
                  (0,1) * grav%psi(3)%a(2) - grav%psi(4)%a(1)
    g0_grav%a(3) = -grav%psi(1)%a(4) - grav%psi(2)%a(3) - &
                  (0,1) * grav%psi(3)%a(3) + grav%psi(4)%a(4)
    g0_grav%a(4) = grav%psi(1)%a(3) + grav%psi(2)%a(4) - &
                  (0,1) * grav%psi(3)%a(4) + grav%psi(4)%a(3)
    g1_grav%a(1) = grav%psi(1)%a(1) - grav%psi(2)%a(2) - & 
                  (0,1) * grav%psi(3)%a(2) + grav%psi(4)%a(1) 
    g1_grav%a(2) = -grav%psi(1)%a(2) + grav%psi(2)%a(1) - &
                  (0,1) * grav%psi(3)%a(1) + grav%psi(4)%a(2)
    g1_grav%a(3) = -grav%psi(1)%a(3) - grav%psi(2)%a(4) - &
                  (0,1) * grav%psi(3)%a(4) + grav%psi(4)%a(3)
    g1_grav%a(4) = grav%psi(1)%a(4) + grav%psi(2)%a(3) - &
                  (0,1) * grav%psi(3)%a(3) + grav%psi(4)%a(4)
    g2_grav%a(1) = (0,1) * (grav%psi(1)%a(1) + grav%psi(2)%a(2) + &
                  grav%psi(4)%a(1)) - grav%psi(3)%a(2)
    g2_grav%a(2) = (0,1) * (grav%psi(1)%a(2) + grav%psi(2)%a(1) - &
                  grav%psi(4)%a(2)) + grav%psi(3)%a(1)
    g2_grav%a(3) = (0,-1) * (grav%psi(1)%a(3) + grav%psi(2)%a(4) - & 
                  grav%psi(4)%a(3)) - grav%psi(3)%a(4)
    g2_grav%a(4) = (0,-1) * (grav%psi(1)%a(4) + grav%psi(2)%a(3) + &
                  grav%psi(4)%a(4)) + grav%psi(3)%a(3)  
    g3_grav%a(1) = -grav%psi(1)%a(2) - grav%psi(2)%a(1) - &
                  (0,1) * grav%psi(3)%a(1) - grav%psi(4)%a(2)
    g3_grav%a(2) = -grav%psi(1)%a(1) - grav%psi(2)%a(2) + &
                  (0,1) * grav%psi(3)%a(2) + grav%psi(4)%a(1)
    g3_grav%a(3) = grav%psi(1)%a(4) - grav%psi(2)%a(3) - &
                  (0,1) * grav%psi(3)%a(3) - grav%psi(4)%a(4)
    g3_grav%a(4) = grav%psi(1)%a(3) - grav%psi(2)%a(4) + &
                  (0,1) * grav%psi(3)%a(4) + grav%psi(4)%a(3)
    j%t    =   (g * phi) * (psibar * g0_grav)
    j%x(1) =   (g * phi) * (psibar * g1_grav)
    j%x(2) =   (g * phi) * (psibar * g2_grav)
    j%x(3) =   (g * phi) * (psibar * g3_grav)
  end function sv2_fgr
  pure function pv1_grf (g, gravbar, v, psi) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    j = g * grvgf (gravbar, psi, v)
  end function pv1_grf 
  pure function pv2_grf (g, gravbar, phi, psi) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: g, phi
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(bispinor) :: g5_psi
    g5_psi%a(1:2) = - psi%a(1:2)
    g5_psi%a(3:4) = psi%a(3:4)
    j = sv2_grf (g, gravbar, phi, g5_psi)
  end function pv2_grf
  pure function pv1_fgr (g, psibar, v, grav) result (j)
    complex(kind=omega_prec) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: psibar
    type(vectorspinor), intent(in) :: grav
    type(vector), intent(in) :: v
    j = g * fgkgr (psibar, grav, v) 
  end function pv1_fgr
  pure function pv2_fgr (g, psibar, phi, grav) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: g, phi
    type(vectorspinor), intent(in) :: grav
    type(bispinor), intent(in) :: psibar
    type(bispinor) :: psibar_g5
    psibar_g5%a(1:2) = - psibar%a(1:2)
    psibar_g5%a(3:4) = psibar%a(3:4)
    j = sv2_fgr (g, psibar_g5, phi, grav)
  end function pv2_fgr 
  pure function v2_grf (g, gravbar, v, psi) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: gravbar
    type(bispinor), intent(in) :: psi
    type(vector), intent(in) :: v
    j = -g * grkgggf (gravbar, psi, v) 
  end function v2_grf 
  pure function v2_fgr (g, psibar, v, grav) result (j)
    type(vector) :: j
    complex(kind=omega_prec), intent(in) :: g
    type(vectorspinor), intent(in) :: grav
    type(bispinor), intent(in) :: psibar
    type(vector), intent(in) :: v
    j = -g * fggkggr (psibar, grav, v) 
  end function v2_fgr
  pure function pr_psi (p, m, w, psi) result (ppsi)
    type(bispinor) :: ppsi
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: m, w
    type(bispinor), intent(in) :: psi
    type(vector) :: vp
    complex(kind=omega_prec), parameter :: one = (1, 0)
    vp = p
    ppsi = (1 / cmplx (p*p - m**2, m*w, kind=omega_prec)) &
         * (- f_vf (one, vp, psi) + m * psi)  
  end function pr_psi
  pure function pj_psi (p, m, w, psi) result (ppsi)
    type(bispinor) :: ppsi
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: m, w
    type(bispinor), intent(in) :: psi
    type(vector) :: vp
    complex(kind=omega_prec), parameter :: one = (1, 0)
    vp = p
    ppsi = (0, -1) * sqrt (PI / m / w) * (- f_vf (one, vp, psi) + m * psi)  
  end function pj_psi
  pure function pr_grav (p, m, w, grav) result (propgrav)
    type(vectorspinor) :: propgrav
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: m, w
    type(vectorspinor), intent(in) :: grav
    type(vector) :: vp
    type(bispinor) :: pgrav, ggrav, ggrav1, ggrav2, ppgrav
    type(vectorspinor) :: etagrav_dum, etagrav, pppgrav, &
                          gg_grav_dum, gg_grav
    complex(kind=omega_prec), parameter :: one = (1, 0)
    real(kind=omega_prec) :: minv
    integer :: i 
    vp = p
    minv = 1/m
    pgrav = p%t    * grav%psi(1) - p%x(1) * grav%psi(2) - &
            p%x(2) * grav%psi(3) - p%x(3) * grav%psi(4)
    ggrav%a(1) = grav%psi(1)%a(3) - grav%psi(2)%a(4) + (0,1) * &
                 grav%psi(3)%a(4) - grav%psi(4)%a(3)
    ggrav%a(2) = grav%psi(1)%a(4) - grav%psi(2)%a(3) - (0,1) * &
                 grav%psi(3)%a(3) + grav%psi(4)%a(4)
    ggrav%a(3) = grav%psi(1)%a(1) + grav%psi(2)%a(2) - (0,1) * &
                 grav%psi(3)%a(2) + grav%psi(4)%a(1)
    ggrav%a(4) = grav%psi(1)%a(2) + grav%psi(2)%a(1) + (0,1) * &
                 grav%psi(3)%a(1) - grav%psi(4)%a(2)
    ggrav1 = ggrav - minv * pgrav 
    ggrav2 = f_vf (one, vp, ggrav1) + m * ggrav - pgrav
    ppgrav = -minv**2 * f_vf (one, vp, pgrav) + minv * pgrav
    do i = 1, 4
    etagrav_dum%psi(i) = f_vf (one, vp, grav%psi(i))
    end do 
    etagrav = etagrav_dum - m * grav
    pppgrav%psi(1) = p%t    * ppgrav
    pppgrav%psi(2) = p%x(1) * ppgrav
    pppgrav%psi(3) = p%x(2) * ppgrav
    pppgrav%psi(4) = p%x(3) * ppgrav
    gg_grav_dum%psi(1) = p%t    * ggrav2
    gg_grav_dum%psi(2) = p%x(1) * ggrav2
    gg_grav_dum%psi(3) = p%x(2) * ggrav2
    gg_grav_dum%psi(4) = p%x(3) * ggrav2
    gg_grav = gr_potf (one, one, ggrav2) - minv * gg_grav_dum  
    propgrav = (1 / cmplx (p*p - m**2, m*w, kind=omega_prec)) * &
         (etagrav + pppgrav + (1/3.0_omega_prec) * gg_grav)
  end function pr_grav
end module omega_bispinor_couplings
